/***************************************************************************
                          scaledialog.h  -  description
                             -------------------
    begin                : Sun May 5 2002
    copyright            : (C) 2002 by Michael Herder
    email                : crapsite@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SCALEDIALOG_H
#define SCALEDIALOG_H

#include "imagefilterdialog.h"
#include <qpixmap.h>

/**
  *@author Michael Herder
  */
class QCheckBox;
class QDoubleSpinBox;
class QHBox;
class QPushButton;
class QSpinBox;

class ScaleDialog : public ImageFilterDialog
{
Q_OBJECT
public:
  ScaleDialog(int preview_size=150,QImage* image=0,QWidget* parent=0);
  ~ScaleDialog();
  /** No descriptions */
  bool apply(QImage* image,bool emit_progress=true);
  /** No descriptions */
  virtual void setImage(QImage* image);
protected:
  /** No descriptions */
  void saveConfig();
private: // Private methods
  /** No descriptions */
  int mMaxSize;
  /** No descriptions */
  void resizeImage(QImage image);
  /** No descriptions */
  void initControls();
  /** No descriptions */
  QSpinBox* mpScaleHSpin;
  /** No descriptions */
  QSpinBox* mpScaleVSpin;
  /** No descriptions */
  QSpinBox* mpScaleHDoubleSpin;
  /** No descriptions */
  QSpinBox* mpScaleVDoubleSpin;
  /** No descriptions */
  QCheckBox* mpAspectCheckBox;
  /** No descriptions */
  QPushButton* mpResetButton;
private slots:
  /** No descriptions */
  void slotScaleFactorHChanged(int fh);
  /** No descriptions */
  void slotScaleFactorVChanged(int fv);
  /** No descriptions */
  void slotScaleHChanged(int width);
  /** No descriptions */
  void slotScaleVChanged(int height);
  /** No descriptions */
  void slotAspect(bool state);
  /** No descriptions */
  void slotReset();

};

#endif
