/***************************************************************************
                          sheardialog.h  -  description
                             -------------------
    begin                : Thu Mar 7 2002
    copyright            : (C) 2002 by Michael Herder
    email                : crapsite@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SHEARDIALOG_H
#define SHEARDIALOG_H

#include "imagefilterdialog.h"
#include <qcolor.h>
#include <qpixmap.h>
#include <qwmatrix.h>

/**
  *@author Michael Herder
  */
class QCheckBox;
class QDoubleSpinBox;
class QHBox;
class QPushButton;

class ShearDialog : public ImageFilterDialog
{
Q_OBJECT
public:
	ShearDialog(int preview_size=150,QImage* image=0,QWidget* parent=0);
	~ShearDialog();
  /** No descriptions */
  bool apply(QImage* image,bool emit_progress=true);
protected:
  /** No descriptions */
  void saveConfig();
private: // Private methods
  /** No descriptions */
  void resizeImage(QImage image);
  /** No descriptions */
  void initControls();
  /** No descriptions */
  QDoubleSpinBox* mpShearHSpin;
  /** No descriptions */
  QDoubleSpinBox* mpShearVSpin;
  /** No descriptions */
  QCheckBox* mpTransparentCheckBox;
  /** No descriptions */
  QPushButton* mpBgButton;
  /** No descriptions */
  QHBox* mpBgHBox;
  /** No descriptions */
  QRgb mBgColor;
  /** No descriptions */
  QPixmap mPixmap;
  /** No descriptions */
  QWMatrix mMatrix;
  /** No descriptions */
  QWMatrix mInvertedMatrix;
  /** No descriptions */
  int mOffX;
  /** No descriptions */
  int mOffY;
  /** No descriptions */
  double mShearH;
  /** No descriptions */
  double mShearV;
private slots:
  /** No descriptions */
  void slotShearHChanged(int shearh);
  /** No descriptions */
  void slotShearVChanged(int shearv);
  /** No descriptions */
  void slotTransparency(bool state);
  /** No descriptions */
  void slotBgColor();
};

#endif
