/***************************************************************************
                          transparencydialog.h  -  description
                             -------------------
    begin                : Sat Sep 28 2002
    copyright            : (C) 2002 by Michael Herder
    email                : crapsite@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TRANSPARENCYDIALOG_H
#define TRANSPARENCYDIALOG_H

#include "imagefilterdialog.h"

/**
  *@author Michael Herder
  */
class SliderSpin;
class QCheckButton;
class QPushButton;
class QTabWidget;

class TransparencyDialog : public ImageFilterDialog
{
Q_OBJECT
public:
  TransparencyDialog(int preview_size=150,QImage* image=0,QWidget* parent=0);
  ~TransparencyDialog();
  /** No descriptions */
  bool apply(QImage* image,bool emit_progress=true);
protected:
  /** No descriptions */
  void saveConfig();
private: // Private methods
  /** No descriptions */
  void initControls();
  /** No descriptions */
  QTabWidget* mpTabWidget;
  /** No descriptions */
  QCheckBox* mpHueCheckBox;
  /** No descriptions */
  SliderSpin* mpMaxHueSlider;
  /** No descriptions */
  SliderSpin* mpMinHueSlider;
  /** No descriptions */
  QCheckBox* mpSatCheckBox;
  /** No descriptions */
  SliderSpin* mpMaxSatSlider;
  /** No descriptions */
  SliderSpin* mpMinSatSlider;
  /** No descriptions */
  QCheckBox* mpValCheckBox;
  /** No descriptions */
  SliderSpin* mpMaxValSlider;
  /** No descriptions */
  SliderSpin* mpMinValSlider;

  /** No descriptions */
  QCheckBox* mpRedCheckBox;
  /** No descriptions */
  SliderSpin* mpMaxRedSlider;
  /** No descriptions */
  SliderSpin* mpMinRedSlider;
  /** No descriptions */
  QCheckBox* mpGreenCheckBox;
  /** No descriptions */
  SliderSpin* mpMaxGreenSlider;
  /** No descriptions */
  SliderSpin* mpMinGreenSlider;
  /** No descriptions */
  QCheckBox* mpBlueCheckBox;
  /** No descriptions */
  SliderSpin* mpMaxBlueSlider;
  /** No descriptions */
  SliderSpin* mpMinBlueSlider;
private slots:
  /** No descriptions */
  void slotMinHueChanged(int min);
  /** No descriptions */
  void slotMaxHueChanged(int max);
  /** No descriptions */
  void slotMinSatChanged(int min);
  /** No descriptions */
  void slotMaxSatChanged(int max);
  /** No descriptions */
  void slotMinValChanged(int min);
  /** No descriptions */
  void slotMaxValChanged(int max);
  /** No descriptions */
  void slotHueEnabled(bool enabled);
  /** No descriptions */
  void slotSatEnabled(bool enabled);
  /** No descriptions */
  void slotValEnabled(bool enabled);

  /** No descriptions */
  void slotMinRedChanged(int min);
  /** No descriptions */
  void slotMaxRedChanged(int max);
  /** No descriptions */
  void slotMinGreenChanged(int min);
  /** No descriptions */
  void slotMaxGreenChanged(int max);
  /** No descriptions */
  void slotMinBlueChanged(int min);
  /** No descriptions */
  void slotMaxBlueChanged(int max);
  /** No descriptions */
  void slotRedEnabled(bool enabled);
  /** No descriptions */
  void slotGreenEnabled(bool enabled);
  /** No descriptions */
  void slotBlueEnabled(bool enabled);
  /** No descriptions */
  void slotChangeMode(QWidget*);
};

#endif
